/**
 ** Copyright (c) 2002 Sun Microsystems, Inc.
 **
 ** See the file "license.terms" for information on usage and redistribution
 ** of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 **/

/**
 **  gcspy_shape_stream.hpp
 **
 **  Instantiation of the command stream
 **/

#ifndef _GCSPY_SHAPE_STREAM_HPP_

#define _GCSPY_SHAPE_STREAM_HPP_

#include "gcspy_command_stream.hpp"

class gcspyShapeStream : public gcspyCommandStream {
  friend void point_cmd (gcspyBufferedInput *input, void *aux);
  friend void circle_cmd (gcspyBufferedInput *input, void *aux);
  friend void rectangle_cmd (gcspyBufferedInput *input, void *aux);

private:
  enum PrivateConstants {
    point_tag = first_available_tag,
    circle_tag,
    rectangle_tag,

    last_tag = rectangle_tag
  };

public:
  gcspyShapeStream();

  inline void execute (gcspyBufferedInput *input) {
    gcspyCommandStream::execute(input, NULL);
  }

  void put_point (gcspyBufferedOutput *output,
		  int x, int y);
  void put_circle (gcspyBufferedOutput *output,
		   int x, int y, int rad);
  void put_rectangle (gcspyBufferedOutput *output, 
		      int x1, int y1, int x2, int y2);
};


#endif //_GCSPY_SHAPE_STREAM_HPP_
