/**
 ** Copyright (c) 2002 Sun Microsystems, Inc.
 **
 ** See the file "license.terms" for information on usage and redistribution
 ** of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 **/

#include <stdio.h>

#include "gcspy_shape_stream.hpp"

int main() {
  gcspyShapeStream stream;
  char buffer[2048];
  gcspyBufferedOutput output = gcspyBufferedOutput(buffer, 2048);

  stream.start(&output);
  stream.put_point(&output, 2, 3);
  stream.put_circle(&output, 3, 5, 2);
  stream.put_rectangle(&output, 2, 3, 10, 12);
  stream.put_rectangle(&output, -2, -3, 3, 4);
  stream.put_point(&output, 4, 3);
  stream.put_point(&output, 1, 2);
  stream.put_circle(&output, 1, 2, 3);
  stream.finish(&output);

  gcspyBufferedInput input = gcspyBufferedInput(buffer, output.get_len());
  stream.execute(&input);
}
