package gcspy.vis;

import gcspy.interpreter.client.ClientInterpreter;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * {@link EnhancedThread} for running a {@link ClientInterpreter} instance's
 * main loop.
 * 
 * @author Peter Hofer
 */
public class ClientInterpreterThread extends EnhancedThread {
	private static final Logger logger = Logger.getLogger(ClientInterpreterThread.class.getName());

	private final ClientInterpreter interpreter;

	public ClientInterpreterThread(ClientInterpreter interpreter) {
		this.interpreter = interpreter;
	}

	@Override
	protected void execute() {
		try {
			interpreter.mainLoop();
		} catch (Exception e) {
			logger.log(Level.SEVERE, "Exception caught, client interpreter stops", e);
		}
	}
}
