package gcspy.vis;

/**
 * Listener for property source changes.
 * 
 * @author Peter Hofer
 */
public interface PropertySourceListener<T> {

	/**
	 * Indicates that the provider of property data for the specified view has
	 * changed.
	 * 
	 * @param view
	 *            The view for which the property provider has changed.
	 * @param newProvider
	 *            The new property provider for the given view (may be
	 *            <code>null</code>).
	 */
	public void propertySourceChanged(PropertyView<T> view, Object newProvider);

}
