/**
 ** $Id: TimersFrame.java 22 2005-06-14 05:17:45Z rej $
 ** Copyright (c) 2002 Sun Microsystems, Inc.
 **
 ** See the file "license.terms" for information on usage and redistribution
 ** of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 **/

package gcspy.vis;

import gcspy.interpreter.client.EventCommandListener;
import gcspy.vis.utils.Factory;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.table.TableColumnModel;

/**
 * Component displaying timer information.
 * 
 * @author Tony Printezis
 */
class TimersView extends JComponent {

	private JTable table;
	private TimersTableModel model;

	private InterpreterEventProvider provider;

	private EventCommandListener eventCommandListener = new EventCommandListener() {
		public void onEventCmd(int eventID, int elapsedTime, int compensationTime) {
			model.setData(elapsedTime, compensationTime);
		}
	};

	/**
	 * Constructor.
	 */
	TimersView() {
		setLayout(new BorderLayout());

		model = new TimersTableModel();
		table = Factory.createTable(model);

		TableColumnModel columnModel = table.getColumnModel();
		columnModel.getColumn(0).setPreferredWidth(200);
		columnModel.getColumn(1).setPreferredWidth(100);

		add(table, BorderLayout.CENTER);
	}

	public void setEventProvider(InterpreterEventProvider provider) {
		if (this.provider != null) {
			this.provider.removeEventListener(eventCommandListener);
		}

		if (provider != null) {
			provider.addEventListener(eventCommandListener);
		}
		this.provider = provider;
	}

}
